diff -urN systemd-216/src/libsystemd-terminal/term-screen.c systemd-217/src/libsystemd-terminal/term-screen.c
--- systemd-216/src/libsystemd-terminal/term-screen.c	2014-11-03 09:35:35.423252073 -0800
+++ systemd-217/src/libsystemd-terminal/term-screen.c	2014-10-17 04:49:07.965593679 -0700
@@ -392,126 +392,117 @@
                 screen->flags &= ~flag;
 }
 
-static void screen_mode_change(term_screen *screen, unsigned int mode, bool dec, bool set) {
+static void screen_mode_change_ansi(term_screen *screen, unsigned mode, bool set) {
+        switch (mode) {
+        case 20:
+                /*
+                 * LNM: line-feed/new-line mode
+                 * TODO
+                 */
+                set_reset(screen, TERM_FLAG_NEWLINE_MODE, set);
+
+                break;
+        default:
+                log_debug("terminal: failed to %s unknown ANSI mode %u", set ? "set" : "unset", mode);
+        }
+}
+
+static void screen_mode_change_dec(term_screen *screen, unsigned int mode, bool set) {
         switch (mode) {
         case 1:
-                if (dec) {
-                        /*
-                         * DECCKM: cursor-keys
-                         * TODO
-                         */
-                        set_reset(screen, TERM_FLAG_CURSOR_KEYS, set);
-                }
+                /*
+                 * DECCKM: cursor-keys
+                 * TODO
+                 */
+                set_reset(screen, TERM_FLAG_CURSOR_KEYS, set);
 
                 break;
         case 6:
-                if (dec) {
-                        /*
-                         * DECOM: origin-mode
-                         * TODO
-                         */
-                        screen->state.origin_mode = set;
-                }
+                /*
+                 * DECOM: origin-mode
+                 * TODO
+                 */
+                screen->state.origin_mode = set;
 
                 break;
         case 7:
-                if (dec) {
-                        /*
-                         * DECAWN: auto-wrap mode
-                         * TODO
-                         */
-                        screen->state.auto_wrap = set;
-                }
-
-                break;
-        case 20:
-                if (!dec) {
-                        /*
-                         * LNM: line-feed/new-line mode
-                         * TODO
-                         */
-                        set_reset(screen, TERM_FLAG_NEWLINE_MODE, set);
-                }
+                /*
+                 * DECAWN: auto-wrap mode
+                 * TODO
+                 */
+                screen->state.auto_wrap = set;
 
                 break;
         case 25:
-                if (dec) {
-                        /*
-                         * DECTCEM: text-cursor-enable
-                         * TODO
-                         */
-                        set_reset(screen, TERM_FLAG_HIDE_CURSOR, !set);
-                        screen_age_cursor(screen);
-                }
+                /*
+                 * DECTCEM: text-cursor-enable
+                 * TODO
+                 */
+                set_reset(screen, TERM_FLAG_HIDE_CURSOR, !set);
+                screen_age_cursor(screen);
 
                 break;
         case 47:
-                if (dec) {
-                        /*
-                         * XTERM-ASB: alternate-screen-buffer
-                         * This enables/disables the alternate screen-buffer.
-                         * It effectively saves the current page content and
-                         * allows you to restore it when changing to the
-                         * original screen-buffer again.
-                         */
-                        screen_change_alt(screen, set);
-                }
+                /*
+                 * XTERM-ASB: alternate-screen-buffer
+                 * This enables/disables the alternate screen-buffer.
+                 * It effectively saves the current page content and
+                 * allows you to restore it when changing to the
+                 * original screen-buffer again.
+                 */
+                screen_change_alt(screen, set);
 
                 break;
         case 1047:
-                if (dec) {
-                        /*
-                         * XTERM-ASBPE: alternate-screen-buffer-post-erase
-                         * This is the same as XTERM-ASB but erases the
-                         * alternate screen-buffer before switching back to the
-                         * original buffer. Use it to discard any data on the
-                         * alternate screen buffer when done.
-                         */
-                        if (!set)
-                                screen_reset_page(screen, screen->page_alt);
+                /*
+                 * XTERM-ASBPE: alternate-screen-buffer-post-erase
+                 * This is the same as XTERM-ASB but erases the
+                 * alternate screen-buffer before switching back to the
+                 * original buffer. Use it to discard any data on the
+                 * alternate screen buffer when done.
+                 */
+                if (!set)
+                        screen_reset_page(screen, screen->page_alt);
 
-                        screen_change_alt(screen, set);
-                }
+                screen_change_alt(screen, set);
 
                 break;
         case 1048:
-                if (dec) {
-                        /*
-                         * XTERM-ASBCS: alternate-screen-buffer-cursor-state
-                         * This has the same effect as DECSC/DECRC, but uses a
-                         * separate state buffer. It is usually used in
-                         * combination with alternate screen buffers to provide
-                         * stacked state storage.
-                         */
-                        if (set)
-                                screen_save_state(screen, &screen->saved_alt);
-                        else
-                                screen_restore_state(screen, &screen->saved_alt);
-                }
+                /*
+                 * XTERM-ASBCS: alternate-screen-buffer-cursor-state
+                 * This has the same effect as DECSC/DECRC, but uses a
+                 * separate state buffer. It is usually used in
+                 * combination with alternate screen buffers to provide
+                 * stacked state storage.
+                 */
+                if (set)
+                        screen_save_state(screen, &screen->saved_alt);
+                else
+                        screen_restore_state(screen, &screen->saved_alt);
 
                 break;
         case 1049:
-                if (dec) {
-                        /*
-                         * XTERM-ASBX: alternate-screen-buffer-extended
-                         * This combines XTERM-ASBPE and XTERM-ASBCS somewhat.
-                         * When enabling, state is saved, alternate screen
-                         * buffer is activated and cleared.
-                         * When disabled, alternate screen buffer is cleared,
-                         * then normal screen buffer is enabled and state is
-                         * restored.
-                         */
-                        if (set)
-                                screen_save_state(screen, &screen->saved_alt);
+                /*
+                 * XTERM-ASBX: alternate-screen-buffer-extended
+                 * This combines XTERM-ASBPE and XTERM-ASBCS somewhat.
+                 * When enabling, state is saved, alternate screen
+                 * buffer is activated and cleared.
+                 * When disabled, alternate screen buffer is cleared,
+                 * then normal screen buffer is enabled and state is
+                 * restored.
+                 */
+                if (set)
+                        screen_save_state(screen, &screen->saved_alt);
+
+                screen_reset_page(screen, screen->page_alt);
+                screen_change_alt(screen, set);
 
-                        screen_reset_page(screen, screen->page_alt);
-                        screen_change_alt(screen, set);
-
-                        if (!set)
-                                screen_restore_state(screen, &screen->saved_alt);
-                }
+                if (!set)
+                        screen_restore_state(screen, &screen->saved_alt);
 
                 break;
+        default:
+                log_debug("terminal: failed to %s unknown DEC mode %u", set ? "set" : "unset", mode);
         }
 }
 
@@ -2763,7 +2754,7 @@
         unsigned int i;
 
         for (i = 0; i < seq->n_args; ++i)
-                screen_mode_change(screen, seq->args[i], false, false);
+                screen_mode_change_ansi(screen, seq->args[i], false);
 
         return 0;
 }
@@ -2777,7 +2768,7 @@
         unsigned int i;
 
         for (i = 0; i < seq->n_args; ++i)
-                screen_mode_change(screen, seq->args[i], true, false);
+                screen_mode_change_dec(screen, seq->args[i], false);
 
         return 0;
 }
@@ -3057,7 +3048,7 @@
         unsigned int i;
 
         for (i = 0; i < seq->n_args; ++i)
-                screen_mode_change(screen, seq->args[i], false, true);
+                screen_mode_change_ansi(screen, seq->args[i], true);
 
         return 0;
 }
@@ -3071,7 +3062,7 @@
         unsigned int i;
 
         for (i = 0; i < seq->n_args; ++i)
-                screen_mode_change(screen, seq->args[i], true, true);
+                screen_mode_change_dec(screen, seq->args[i], true);
 
         return 0;
 }
diff -urN systemd-216/src/libsystemd-terminal/unifont-def.h systemd-217/src/libsystemd-terminal/unifont-def.h
--- systemd-216/src/libsystemd-terminal/unifont-def.h	1969-12-31 16:00:00.000000000 -0800
+++ systemd-217/src/libsystemd-terminal/unifont-def.h	2014-10-07 06:59:01.461580544 -0700
@@ -0,0 +1,137 @@
+/*-*- Mode: C; c-basic-offset: 8; indent-tabs-mode: nil -*-*/
+
+/***
+  This file is part of systemd.
+
+  Copyright (C) 2014 David Herrmann <dh.herrmann@gmail.com>
+
+  systemd is free software; you can redistribute it and/or modify it
+  under the terms of the GNU Lesser General Public License as published by
+  the Free Software Foundation; either version 2.1 of the License, or
+  (at your option) any later version.
+
+  systemd is distributed in the hope that it will be useful, but
+  WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+  Lesser General Public License for more details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with systemd; If not, see <http://www.gnu.org/licenses/>.
+***/
+
+#pragma once
+
+#include <stdbool.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include "sparse-endian.h"
+#include "util.h"
+
+typedef struct unifont_header unifont_header;
+typedef struct unifont_glyph_header unifont_glyph_header;
+
+/*
+ * Unifont: On-disk data
+ * Conventional font-formats have the problem that you have to pre-render each
+ * glyph before you can use it. If you just need one glyph, you have to parse
+ * the font-file until you found that glyph.
+ * GNU-Unifont is a bitmap font with very good Unicode coverage. All glyphs are
+ * (n*8)x16 bitmaps. Our on-disk data stores all those glyphs pre-compiled with
+ * fixed offsets. Therefore, the font-file can be mmap()ed and all glyphs can
+ * be accessed in O(1) (because all glyphs have the same size and thus their
+ * offsets can be easily computed). This guarantees, that the kernel only loads
+ * the pages that are really accessed. Thus, we have a far lower overhead than
+ * traditional font-formats like BDF. Furthermore, the backing file is read-only
+ * and can be shared in memory between multiple users.
+ *
+ * The binary-format starts with a fixed header:
+ *
+ *      | 2bytes | 2bytes | 2bytes | 2bytes |
+ *
+ *      +-----------------------------------+
+ *      |             SIGNATURE             |   8 bytes
+ *      +-----------------+-----------------+
+ *      |  COMPAT FLAGS   | INCOMPAT FLAGS  |   8 bytes
+ *      +-----------------+--------+--------+
+ *      |   HEADER SIZE   |GH-SIZE |G-STRIDE|   8 bytes
+ *      +-----------------+--------+--------+
+ *      |          GLYPH BODY SIZE          |   8 bytes
+ *      +-----------------------------------+
+ *
+ *  * The 8 bytes signature must be set to the ASCII string "DVDHRMUF".
+ *  * The 4 bytes compatible-flags field contains flags for new features that
+ *    might be added in the future and which are compatible to older parsers.
+ *  * The 4 bytes incompatible-flags field contains flags for new features that
+ *    might be added in the future and which are incompatible to old parses.
+ *    Thus, if you encounter an unknown bit set, you must abort!
+ *  * The 4 bytes header-size field contains the size of the header in bytes. It
+ *    must be at least 32 (the size of this fixed header). If new features are
+ *    added, it might be increased. It can also be used to add padding to the
+ *    end of the header.
+ *  * The 2 bytes glyph-header-size field specifies the size of each glyph
+ *    header in bytes (see below).
+ *  * The 2 bytes glyph-stride field specifies the stride of each line of glyph
+ *    data in "bytes per line".
+ *  * The 8 byte glyph-body-size field defines the size of each glyph body in
+ *    bytes.
+ *
+ * After the header, the file can contain padding bytes, depending on the
+ * header-size field. Everything beyond the header+padding is treated as a big
+ * array of glyphs. Each glyph looks like this:
+ *
+ *      |              1 byte               |
+ *
+ *      +-----------------------------------+
+ *      |               WIDTH               |   1 byte
+ *      +-----------------------------------+
+ *      ~              PADDING              ~
+ *      +-----------------------------------+
+ *      ~                                   ~
+ *      ~                                   ~
+ *      ~                DATA               ~
+ *      ~                                   ~
+ *      ~                                   ~
+ *      +-----------------------------------+
+ *
+ *  * The first byte specifies the width of the glyph. If it is 0, the glyph
+ *    must be treated as non-existant.
+ *    All glyphs are "8*n" pixels wide and "16" pixels high. The width-field
+ *    specifies the width multiplier "n".
+ *  * After the width field padding might be added. This depends on the global
+ *    glyph-header-size field. It defines the total size of each glyph-header.
+ *    After the glyph-header+padding, the data-field starts.
+ *  * The data-field contains a byte-array of bitmap data. The array is always
+ *    as big as specified in the global glyph-body-size header field. This might
+ *    include padding.
+ *    The array contains all 16 lines of bitmap information for that glyph. The
+ *    stride is given in the global glyph-stride header field. This can be used
+ *    to add padding after each line.
+ *    Each line is encoded as 1 bit per pixel bitmap. That is, each byte encodes
+ *    data for 8 pixels (left most pixel is encoded in the LSB, right most pixel
+ *    in the MSB). The width field defines the number of bytes valid per line.
+ *    For width==1, you need 1 byte to encode the 8 pixels. The stride defines
+ *    where the encoding of the next line starts.
+ *    Any data beyond the 16th line is padding and must be ignored.
+ */
+
+/* path to binary file */
+#define UNIFONT_PATH "/usr/share/systemd/unifont-glyph-array.bin"
+
+/* header-size of version 1 */
+#define UNIFONT_HEADER_SIZE_MIN 32
+
+struct unifont_header {
+        /* fields available in version 1 */
+        uint8_t signature[8];
+        le32_t compatible_flags;
+        le32_t incompatible_flags;
+        le32_t header_size;
+        le16_t glyph_header_size;
+        le16_t glyph_stride;
+        le64_t glyph_body_size;
+} _packed_;
+
+struct unifont_glyph_header {
+        /* fields available in version 1 */
+        uint8_t width;
+} _packed_;
diff -urN systemd-216/src/libudev/libudev.c systemd-217/src/libudev/libudev.c
--- systemd-216/src/libudev/libudev.c	2014-03-18 10:05:49.964378252 -0700
+++ systemd-217/src/libudev/libudev.c	2014-11-03 09:33:49.192180945 -0800
@@ -119,7 +119,7 @@
 {
         struct udev *udev;
         const char *env;
-        FILE *f;
+        _cleanup_fclose_ FILE *f = NULL;
 
         udev = new0(struct udev, 1);
         if (udev == NULL)
@@ -132,7 +132,7 @@
         f = fopen("/etc/udev/udev.conf", "re");
         if (f != NULL) {
                 char line[UTIL_LINE_SIZE];
-                int line_nr = 0;
+                unsigned line_nr = 0;
 
                 while (fgets(line, sizeof(line), f)) {
                         size_t len;
@@ -153,7 +153,7 @@
                         /* split key/value */
                         val = strchr(key, '=');
                         if (val == NULL) {
-                                udev_err(udev, "missing <key>=<value> in /etc/udev/udev.conf[%i]; skip line\n", line_nr);
+                                udev_err(udev, "/etc/udev/udev.conf:%u: missing assignment,  skipping line.\n", line_nr);
                                 continue;
                         }
                         val[0] = '\0';
@@ -185,7 +185,7 @@
                         /* unquote */
                         if (val[0] == '"' || val[0] == '\'') {
                                 if (val[len-1] != val[0]) {
-                                        udev_err(udev, "inconsistent quoting in /etc/udev/udev.conf[%i]; skip line\n", line_nr);
+                                        udev_err(udev, "/etc/udev/udev.conf:%u: inconsistent quoting, skipping line.\n", line_nr);
                                         continue;
                                 }
                                 val[len-1] = '\0';
@@ -193,17 +193,29 @@
                         }
 
                         if (streq(key, "udev_log")) {
-                                udev_set_log_priority(udev, util_log_priority(val));
+                                int prio;
+
+                                prio = util_log_priority(val);
+                                if (prio < 0)
+                                        udev_err(udev, "/etc/udev/udev.conf:%u: invalid logging level '%s', ignoring.\n", line_nr, val);
+                                else
+                                        udev_set_log_priority(udev, prio);
                                 continue;
                         }
                 }
-                fclose(f);
         }
 
         /* environment overrides config */
         env = secure_getenv("UDEV_LOG");
-        if (env != NULL)
-                udev_set_log_priority(udev, util_log_priority(env));
+        if (env != NULL) {
+                int prio;
+
+                prio = util_log_priority(env);
+                if (prio < 0)
+                        udev_err(udev, "$UDEV_LOG specifies invalid logging level '%s', ignoring.\n", env);
+                else
+                        udev_set_log_priority(udev, prio);
+        }
 
         return udev;
 }
diff -urN systemd-216/src/libudev/libudev-hwdb.c systemd-217/src/libudev/libudev-hwdb.c
--- systemd-216/src/libudev/libudev-hwdb.c	2014-08-04 05:58:48.292250117 -0700
+++ systemd-217/src/libudev/libudev-hwdb.c	2014-10-28 06:31:25.105131602 -0700
@@ -256,6 +256,11 @@
         return 0;
 }
 
+static const char hwdb_bin_paths[] =
+    "/etc/udev/hwdb.bin\0"
+    UDEVLIBEXECDIR "/hwdb.bin\0";
+
+
 /**
  * udev_hwdb_new:
  * @udev: udev library context
@@ -266,6 +271,7 @@
  **/
 _public_ struct udev_hwdb *udev_hwdb_new(struct udev *udev) {
         struct udev_hwdb *hwdb;
+        const char *hwdb_bin_path;
         const char sig[] = HWDB_SIG;
 
         hwdb = new0(struct udev_hwdb, 1);
@@ -275,30 +281,43 @@
         hwdb->refcount = 1;
         udev_list_init(udev, &hwdb->properties_list, true);
 
-        hwdb->f = fopen("/etc/udev/hwdb.bin", "re");
+        /* find hwdb.bin in hwdb_bin_paths */
+        NULSTR_FOREACH(hwdb_bin_path, hwdb_bin_paths) {
+                hwdb->f = fopen(hwdb_bin_path, "re");
+                if (hwdb->f)
+                        break;
+                else if (errno == ENOENT)
+                        continue;
+                else {
+                        udev_dbg(udev, "error reading %s: %m", hwdb_bin_path);
+                        udev_hwdb_unref(hwdb);
+                        return NULL;
+                }
+        }
+
         if (!hwdb->f) {
-                udev_dbg(udev, "error reading /etc/udev/hwdb.bin: %m");
+                udev_err(udev, "hwdb.bin does not exist, please run udevadm hwdb --update");
                 udev_hwdb_unref(hwdb);
                 return NULL;
         }
 
         if (fstat(fileno(hwdb->f), &hwdb->st) < 0 ||
             (size_t)hwdb->st.st_size < offsetof(struct trie_header_f, strings_len) + 8) {
-                udev_dbg(udev, "error reading /etc/udev/hwdb.bin: %m");
+                udev_dbg(udev, "error reading %s: %m", hwdb_bin_path);
                 udev_hwdb_unref(hwdb);
                 return NULL;
         }
 
         hwdb->map = mmap(0, hwdb->st.st_size, PROT_READ, MAP_SHARED, fileno(hwdb->f), 0);
         if (hwdb->map == MAP_FAILED) {
-                udev_dbg(udev, "error mapping /etc/udev/hwdb.bin: %m");
+                udev_dbg(udev, "error mapping %s: %m", hwdb_bin_path);
                 udev_hwdb_unref(hwdb);
                 return NULL;
         }
 
         if (memcmp(hwdb->map, sig, sizeof(hwdb->head->signature)) != 0 ||
             (size_t)hwdb->st.st_size != le64toh(hwdb->head->file_size)) {
-                udev_dbg(udev, "error recognizing the format of /etc/udev/hwdb.bin");
+                udev_dbg(udev, "error recognizing the format of %s", hwdb_bin_path);
                 udev_hwdb_unref(hwdb);
                 return NULL;
         }
@@ -352,14 +371,25 @@
 }
 
 bool udev_hwdb_validate(struct udev_hwdb *hwdb) {
+        bool found = false;
+        const char* p;
         struct stat st;
 
         if (!hwdb)
                 return false;
         if (!hwdb->f)
                 return false;
-        if (stat("/etc/udev/hwdb.bin", &st) < 0)
+
+        /* if hwdb.bin doesn't exist anywhere, we need to update */
+        NULSTR_FOREACH(p, hwdb_bin_paths) {
+                if (stat(p, &st) >= 0) {
+                        found = true;
+                        break;
+                }
+        }
+        if (!found)
                 return true;
+
         if (timespec_load(&hwdb->st.st_mtim) != timespec_load(&st.st_mtim))
                 return true;
         return false;
diff -urN systemd-216/src/libudev/libudev-util.c systemd-217/src/libudev/libudev-util.c
--- systemd-216/src/libudev/libudev-util.c	2014-11-03 09:35:28.399181249 -0800
+++ systemd-217/src/libudev/libudev-util.c	2014-11-03 09:33:49.044179453 -0800
@@ -159,9 +159,13 @@
         char *endptr;
         int prio;
 
-        prio = strtol(priority, &endptr, 10);
-        if (endptr[0] == '\0' || isspace(endptr[0]))
-                return prio;
+        prio = strtoul(priority, &endptr, 10);
+        if (endptr[0] == '\0' || isspace(endptr[0])) {
+                if (prio >= 0 && prio <= 7)
+                        return prio;
+                else
+                        return -ERANGE;
+        }
 
         return log_level_from_string(priority);
 }
diff -urN systemd-216/src/locale/kbd-model-map systemd-217/src/locale/kbd-model-map
--- systemd-216/src/locale/kbd-model-map	2013-12-10 08:52:49.385960774 -0800
+++ systemd-217/src/locale/kbd-model-map	2014-10-13 08:19:31.023675584 -0700
@@ -16,7 +16,6 @@
 hu101			hu	pc105		qwerty		terminate:ctrl_alt_bksp
 jp106			jp	jp106		-		terminate:ctrl_alt_bksp
 croat			hr	pc105		-		terminate:ctrl_alt_bksp
-fi-latin1		fi	pc105		-		terminate:ctrl_alt_bksp
 it2			it	pc105		-		terminate:ctrl_alt_bksp
 hu			hu	pc105		-		terminate:ctrl_alt_bksp
 sr-latin		rs	pc105		latin		terminate:ctrl_alt_bksp
diff -urN systemd-216/src/locale/localed.c systemd-217/src/locale/localed.c
--- systemd-216/src/locale/localed.c	2014-11-03 09:35:31.295210449 -0800
+++ systemd-217/src/locale/localed.c	2014-10-23 08:13:15.775717913 -0700
@@ -1141,7 +1141,7 @@
         log_open();
 
         umask(0022);
-        label_init("/etc");
+        mac_selinux_init("/etc");
 
         if (argc != 1) {
                 log_error("This program takes no arguments.");
diff -urN systemd-216/src/login/logind-dbus.c systemd-217/src/login/logind-dbus.c
--- systemd-216/src/login/logind-dbus.c	2014-11-03 09:35:22.671123493 -0800
+++ systemd-217/src/login/logind-dbus.c	2014-10-23 08:13:15.776717917 -0700
@@ -1143,7 +1143,7 @@
                 return -ENOMEM;
 
         mkdir_p_label("/etc/udev/rules.d", 0755);
-        label_init("/etc");
+        mac_selinux_init("/etc");
         r = write_string_file_atomic_label(file, rule);
         if (r < 0)
                 return r;
diff -urN systemd-216/src/login/logind-user.c systemd-217/src/login/logind-user.c
--- systemd-216/src/login/logind-user.c	2014-11-03 09:35:36.481262741 -0800
+++ systemd-217/src/login/logind-user.c	2014-10-23 08:23:34.759675549 -0700
@@ -326,7 +326,7 @@
 
                 mkdir(p, 0700);
 
-                if (use_smack())
+                if (mac_smack_use())
                         r = asprintf(&t, "mode=0700,smackfsroot=*,uid=" UID_FMT ",gid=" GID_FMT ",size=%zu", u->uid, u->gid, u->manager->runtime_dir_size);
                 else
                         r = asprintf(&t, "mode=0700,uid=" UID_FMT ",gid=" GID_FMT ",size=%zu", u->uid, u->gid, u->manager->runtime_dir_size);
diff -urN systemd-216/src/machine/machined.c systemd-217/src/machine/machined.c
--- systemd-216/src/machine/machined.c	2014-11-03 09:35:27.869175905 -0800
+++ systemd-217/src/machine/machined.c	2014-10-23 12:36:56.910756036 -0700
@@ -35,6 +35,7 @@
 #include "bus-util.h"
 #include "bus-error.h"
 #include "machined.h"
+#include "label.h"
 
 Manager *manager_new(void) {
         Manager *m;
diff -urN systemd-216/src/network/networkd-address.c systemd-217/src/network/networkd-address.c
--- systemd-216/src/network/networkd-address.c	2014-08-13 05:09:51.594814003 -0700
+++ systemd-217/src/network/networkd-address.c	2014-10-27 10:09:26.607862012 -0700
@@ -482,7 +482,7 @@
                 r = safe_atou(e + 1, &i);
                 if (r < 0) {
                         log_syntax(unit, LOG_ERR, filename, line, EINVAL,
-                                   "Interface prefix length is invalid, ignoring assignment: %s", e + 1);
+                                   "Prefix length is invalid, ignoring assignment: %s", e + 1);
                         return 0;
                 }
 
@@ -499,6 +499,15 @@
                 return 0;
         }
 
+        if (!e && f == AF_INET) {
+                r = in_addr_default_prefixlen(&buffer.in, &n->prefixlen);
+                if (r < 0) {
+                        log_syntax(unit, LOG_ERR, filename, line, EINVAL,
+                                   "Prefix length not specified, and a default one can not be deduced for '%s', ignoring assignment", address);
+                        return 0;
+                }
+        }
+
         if (n->family != AF_UNSPEC && f != n->family) {
                 log_syntax(unit, LOG_ERR, filename, line, EINVAL,
                            "Address is incompatible, ignoring assignment: %s", address);
diff -urN systemd-216/src/network/networkd-dhcp4.c systemd-217/src/network/networkd-dhcp4.c
--- systemd-216/src/network/networkd-dhcp4.c	2014-11-03 09:35:28.909186391 -0800
+++ systemd-217/src/network/networkd-dhcp4.c	2014-10-13 08:19:31.024675581 -0700
@@ -599,7 +599,9 @@
         if (r < 0)
                 return r;
 
-        r = sd_dhcp_client_set_mac(link->dhcp_client, &link->mac);
+        r = sd_dhcp_client_set_mac(link->dhcp_client,
+                                   (const uint8_t *) &link->mac,
+                                   sizeof (link->mac), ARPHRD_ETHER);
         if (r < 0)
                 return r;
 
diff -urN systemd-216/src/network/networkd-link.c systemd-217/src/network/networkd-link.c
--- systemd-216/src/network/networkd-link.c	2014-11-03 09:35:32.686224475 -0800
+++ systemd-217/src/network/networkd-link.c	2014-10-27 04:48:29.294966275 -0700
@@ -344,15 +344,6 @@
                 }
         }
 
-        if (link->dhcp_server) {
-                k = sd_dhcp_server_stop(link->dhcp_server);
-                if (k < 0) {
-                        log_warning_link(link, "Could not stop DHCPv4 server: %s",
-                                         strerror(-r));
-                        r = k;
-                }
-        }
-
         if(link->icmp6_router_discovery) {
 
                 if (link->dhcp6_client) {
@@ -909,7 +900,9 @@
                 return;
         }
 
-        r = sd_dhcp6_client_set_mac(link->dhcp6_client, &link->mac);
+        r = sd_dhcp6_client_set_mac(link->dhcp6_client,
+                                    (const uint8_t *) &link->mac,
+                                    sizeof (link->mac), ARPHRD_ETHER);
         if (r < 0) {
                 link->dhcp6_client = sd_dhcp6_client_unref(link->dhcp6_client);
                 return;
@@ -1647,7 +1640,9 @@
 
                         if (link->dhcp_client) {
                                 r = sd_dhcp_client_set_mac(link->dhcp_client,
-                                                           &link->mac);
+                                                           (const uint8_t *) &link->mac,
+                                                           sizeof (link->mac),
+                                                           ARPHRD_ETHER);
                                 if (r < 0) {
                                         log_warning_link(link,
                                                          "Could not update MAC address in DHCP client: %s",
@@ -1658,7 +1653,9 @@
 
                         if (link->dhcp6_client) {
                                 r = sd_dhcp6_client_set_mac(link->dhcp6_client,
-                                                            &link->mac);
+                                                            (const uint8_t *) &link->mac,
+                                                            sizeof (link->mac),
+                                                            ARPHRD_ETHER);
                                 if (r < 0) {
                                         log_warning_link(link,
                                                          "Could not update MAC address in DHCPv6 client: %s",
